### Name: is.magichypercube
### Title: magic hypercubes
### Aliases: is.semimagichypercube is.magichypercube is.perfect
###   is.diagonally.correct is.latinhypercube
### Keywords: array

### ** Examples

library(abind)
is.semimagichypercube(magiccube.2np1(1))
is.semimagichypercube(magichypercube.4n(1,d=4))

is.perfect(magichypercube.4n(1,d=4))

# Now try an array with minmax(dim(a))==FALSE:
a <- abind(magiccube.2np1(1),magiccube.2np1(1),along=2)
is.semimagichypercube(a,g=TRUE)$rook.sums

#argument boolean can be confusing:
zero <- array(0,rep(3,4))
is.semimagichypercube(a,FUN=is.ok,boolean=FALSE)  # TRUE, because all
                                                  # applications of is.ok()
                                                  # return the same value!

a2 <- magichypercube.4n(m=1,d=4)
is.diagonally.correct(a2)
is.diagonally.correct(a2,g=TRUE)$diag.sums

## To extract corner elements (note FUN(1:n) != FUN(n:1)):
is.diagonally.correct(a2,FUN=function(x){x[1]},g=TRUE)$diag.sums 

#Now for a subhypercube of a magic hypercube that is not semimagic:
is.magic(allsubhypercubes(magiccube.2np1(1))[[10]])

data(hendricks)
is.perfect(hendricks)

#note that Hendricks's magic cube also has many broken diagonals summing
#correctly:

a <- allsubhypercubes(hendricks)
ld <- function(a){length(dim(a))}

jj <- unlist(lapply(a,ld))
f <- function(i){is.perfect(a[[which(jj==2)[i]]])}
all(sapply(1:sum(jj==2),f))

#but this is NOT enough to ensure that it is pandiagonal (but I
#think hendricks is pandiagonal).




